﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EditableObjects
{
    public class MainWindowViewModel
    {
        private List<DataObject> _dataSource;
        private ObservableCollection<string> _traces;

        public MainWindowViewModel()
        {
            _traces = new ObservableCollection<string>(Enumerable.Repeat<string>(string.Empty, 10));
            _dataSource = new List<DataObject>();

            _dataSource.Add(new DataObject("Blue", DataObject.EnumValue.Blue, 1, DateTime.Today, DateTime.Today.AddDays(1)));
            _dataSource.Add(new DataObject("Orange", DataObject.EnumValue.Orange, 2, DateTime.Today, DateTime.Today.AddDays(2)));
            _dataSource.Add(new DataObject("Red", DataObject.EnumValue.Red, 0, DateTime.Today, DateTime.Today.AddDays(-1)));
            _dataSource.Add(new DataObject("Yellow", DataObject.EnumValue.Yellow, 3, DateTime.Today, DateTime.Today.AddDays(3)));

            Trace.Listeners.Add(new MyTraceListener(this));
        }

        public List<DataObject> DataSource
        {
            get { return _dataSource; }
        }

        public ObservableCollection<string> Traces
        {
            get { return _traces; }
        }

        public void AddTrace(string message)
        {
            while (_traces.Count > 9)
                _traces.RemoveAt(9);

            _traces.Insert(0, string.Format("{0} - {1}", DateTime.Now.ToString("T", CultureInfo.InvariantCulture), message));
        }
    }
}
